'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _bunyan = require('bunyan');

var _bunyan2 = _interopRequireDefault(_bunyan);

var _types = require('../constants/types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _bunyan2.default.createLogger({ name: "FieldTypeCaster" });

var FieldTypeCastOMat = (_temp = _class = function () {
  function FieldTypeCastOMat(fieldOMat, key, cacheValidators) {
    _classCallCheck(this, FieldTypeCastOMat);

    this.TYPE = _types.FIELD_CAST_O_MAT;

    this._fieldOMat = fieldOMat;
  }

  _createClass(FieldTypeCastOMat, [{
    key: 'number',
    value: function number() {
      return this._fieldOMat._acceptTypeCaster(function (v) {
        return Number(v);
      });
    }
  }, {
    key: 'float',
    value: function float() {
      return this._fieldOMat._acceptTypeCaster(function (v) {
        return parseFloat(v);
      });
    }
  }, {
    key: 'int',
    value: function int() {
      return this._fieldOMat._acceptTypeCaster(function (v) {
        return parseInt(v);
      });
    }
  }, {
    key: 'string',
    value: function string() {
      return this._fieldOMat._acceptTypeCaster(function (v) {
        return String(v);
      });
    }
  }, {
    key: 'bool',
    value: function bool() {
      return this._fieldOMat._acceptTypeCaster(function (v) {
        return Boolean(v);
      });
    }
  }]);

  return FieldTypeCastOMat;
}(), _class.TYPE = _types.FIELD_CAST_O_MAT, _temp);
exports.default = FieldTypeCastOMat;
//# sourceMappingURL=field-cast-o-mat.js.map