'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _bunyan = require('bunyan');

var _bunyan2 = _interopRequireDefault(_bunyan);

var _types = require('../constants/types');

var _fieldOMat = require('../class-o-mat/field-o-mat');

var _fieldOMat2 = _interopRequireDefault(_fieldOMat);

var _fieldValidatorOMat = require('../class-o-mat/field-validator-o-mat');

var _fieldValidatorOMat2 = _interopRequireDefault(_fieldValidatorOMat);

var _apiField = require('./api-field');

var _apiField2 = _interopRequireDefault(_apiField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var log = _bunyan2.default.createLogger({ name: "ApiField" });

var ApiFieldDynamic = (_temp = _class = function (_ApiField) {
  _inherits(ApiFieldDynamic, _ApiField);

  function ApiFieldDynamic(parent, fieldOMat, paramObjectKey, key) {
    _classCallCheck(this, ApiFieldDynamic);

    var _this = _possibleConstructorReturn(this, (ApiFieldDynamic.__proto__ || Object.getPrototypeOf(ApiFieldDynamic)).call(this, parent, fieldOMat, paramObjectKey));

    _this.TYPE = _types.API_FIELD_DYNAMIC;

    var ValidatorOMat = function (_FieldValidatorOMat) {
      _inherits(ValidatorOMat, _FieldValidatorOMat);

      function ValidatorOMat() {
        _classCallCheck(this, ValidatorOMat);

        return _possibleConstructorReturn(this, (ValidatorOMat.__proto__ || Object.getPrototypeOf(ValidatorOMat)).apply(this, arguments));
      }

      _createClass(ValidatorOMat, [{
        key: '$',
        value: function $() {
          return _get(ValidatorOMat.prototype.__proto__ || Object.getPrototypeOf(ValidatorOMat.prototype), '$', this).call(this).$();
        }
      }]);

      return ValidatorOMat;
    }(_fieldValidatorOMat2.default);

    _this._params.ValidatorOMat = ValidatorOMat;
    return _this;
  }

  _createClass(ApiFieldDynamic, [{
    key: 'field',
    value: function field() {
      var _params = this._params,
          key = _params.key,
          fieldOMat = _params.fieldOMat,
          parent = _params.parent;

      var newFieldOMat = new _fieldOMat2.default().init(this, key);
      this._params.fieldOMat = newFieldOMat;
      return newFieldOMat;
    }
  }, {
    key: 'validate',
    value: function validate() {
      return this.field().validate(this._params.ValidatorOMat);
    }
  }]);

  return ApiFieldDynamic;
}(_apiField2.default), _class.TYPE = _types.API_FIELD_DYNAMIC, _temp);
exports.default = ApiFieldDynamic;
//# sourceMappingURL=api-field-dynamic.js.map