'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _bunyan = require('bunyan');

var _bunyan2 = _interopRequireDefault(_bunyan);

var _types = require('../constants/types');

var _autonumGenerator = require('../util/autonum-generator');

var _autonumGenerator2 = _interopRequireDefault(_autonumGenerator);

var _classOMat = require('../class-o-mat/class-o-mat');

var _classOMat2 = _interopRequireDefault(_classOMat);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _bunyan2.default.createLogger({ name: "ClassGroup" });

var ClassGroup = function () {
  function ClassGroup() {
    _classCallCheck(this, ClassGroup);

    this.TYPE = _types.CLASS_GROUP;

    this._Classes = [];
  }

  _createClass(ClassGroup, [{
    key: 'add',
    value: function add(id, Class) {
      this._Classes[id] = Class;
      return Class;
    }
  }, {
    key: 'delete',
    value: function _delete(id) {
      this._Classes[id] = _types.NONE;
    }
  }, {
    key: 'get',
    value: function get() {
      var id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _types.NONE;

      if (id === _types.NONE) return this._Classes(id);

      return this._Classes[id];
    }
  }, {
    key: 'classes',
    value: function classes() {
      var Classes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _types.NONE;

      if (Classes === _types.NONE) return this._Classes;

      this._Classes = Classes;
    }
  }]);

  return ClassGroup;
}();

exports.default = ClassGroup;
//# sourceMappingURL=class-group.js.map