
import Bunyan from 'bunyan';
const  log = Bunyan.createLogger({name: "AccessorSelectorOMat"});

import _AccessorsOMat from './_accessors-o-mat';
import { getterSetter } from '../methods/field-functions';


class AccessorSelectorOMat extends _AccesssorsOMat { 

  constructor(parent) { 
    super();
    this._params = { 
      parent, 
      accessorGetter: getterSetter
    }
  }

  $() { 
    return this._params.parent.accessorGetter(this._params.accessorGetter);
  }

}

export default AccessorSelectorOMat;
