
import Bunyan from 'bunyan';
const  log = Bunyan.createLogger({name: "FieldTypeCaster"});

import { NONE, CLASS_O_MAT, FIELD, FIELD_CAST_O_MAT } from '../constants/types';

class FieldTypeCastOMat { 
  static TYPE = FIELD_CAST_O_MAT;
  TYPE = FIELD_CAST_O_MAT;

  constructor(fieldOMat, key, cacheValidators) { 
    this._fieldOMat = fieldOMat;
  }

  number() { 
    return this._fieldOMat._acceptTypeCaster((v)=>Number(v));
  }

  float() { 
    return this._fieldOMat._acceptTypeCaster((v)=>parseFloat(v));
  }

  int() { 
    return this._fieldOMat._acceptTypeCaster((v)=>parseInt(v));
  }

  string() { 
    return this._fieldOMat._acceptTypeCaster((v)=>String(v));
  }

  bool() { 
    return this._fieldOMat._acceptTypeCaster((v)=>Boolean(v));
  }
}

export default FieldTypeCastOMat;
