'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _bunyan = require('bunyan');

var _bunyan2 = _interopRequireDefault(_bunyan);

var _types = require('../constants/types');

var _fieldOMat = require('../class-o-mat/field-o-mat');

var _fieldOMat2 = _interopRequireDefault(_fieldOMat);

var _radioOMat = require('../class-o-mat/radio-o-mat');

var _radioOMat2 = _interopRequireDefault(_radioOMat);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _bunyan2.default.createLogger({ name: "Plugin" });

var FieldPlugin = function () {
  function FieldPlugin(parent) {
    _classCallCheck(this, FieldPlugin);

    this._params = {
      parent: parent,
      addedMixins: _types.NONE,
      oMatMixins: _types.NONE
    };
  }

  _createClass(FieldPlugin, [{
    key: 'connectToClassOMat',
    value: function connectToClassOMat(classOMat) {
      var oMatMixins = this._params.oMatMixins;

      if (oMatMixins !== _types.NONE) {
        var _dec, _class;

        var BaseFieldOMat = classOMat._params.FieldOMat;

        var _FieldOMat = (_dec = mixin(oMatMixins), _dec(_class = function (_BaseFieldOMat) {
          _inherits(_FieldOMat, _BaseFieldOMat);

          function _FieldOMat() {
            _classCallCheck(this, _FieldOMat);

            return _possibleConstructorReturn(this, (_FieldOMat.__proto__ || Object.getPrototypeOf(_FieldOMat)).apply(this, arguments));
          }

          return _FieldOMat;
        }(BaseFieldOMat)) || _class);

        ;
        classOMat._params.FieldOMat = _FieldOMat;
      }
    }
  }, {
    key: 'addMixins',
    value: function addMixins(mixins) {
      this._params.addedMixins = mixins;
      return this;
    }
  }, {
    key: 'addOMatMixins',
    value: function addOMatMixins(mixins) {
      this._params.oMatMixins = mixins;
      return this;
    }
  }]);

  return FieldPlugin;
}();

exports.default = FieldPlugin;
//# sourceMappingURL=field-plugin.js.map