'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _bunyan = require('bunyan');

var _bunyan2 = _interopRequireDefault(_bunyan);

var _types = require('../constants/types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _bunyan2.default.createLogger({ name: "Collection" });

var Collection = function () {
  function Collection(parent, key, ___key) {
    var value = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : _types.NONE;

    _classCallCheck(this, Collection);

    this.TYPE = _types.COLLECTION;

    this._params = {
      key: key,
      ___key: ___key,
      parent: parent,
      value: parent[___key]()
    };
  }

  _createClass(Collection, [{
    key: '$',
    value: function $() {
      return this._params.parent;
    }
  }, {
    key: 'values',
    value: function values() {
      return this._params.parent.params()[this._params.___key];
    }
  }, {
    key: 'add',
    value: function add(_value) {
      var _params = this._params,
          ___key = _params.___key,
          parent = _params.parent;

      var value = parent[___key]();
      value = this._add(value, _value);
      return this;
    }
  }, {
    key: 'add$',
    value: function add$(_value) {
      this.add(_value);
      return this._params.parent;
    }
  }, {
    key: 'clear',
    value: function clear() {
      this._params.parent.params()[this._params.___key] = [];
    }
  }, {
    key: 'next',
    value: function next() {
      var _params2 = this._params,
          ___key = _params2.___key,
          parent = _params2.parent;

      var value = parent[___key]();
      var values = this._next(value);
      parent._params[___key] = values.value;
      return values.nextValue;
    }
  }, {
    key: 'next$',
    value: function next$() {
      this.next();
      return this._params.parent();
    }
  }]);

  return Collection;
}();

exports.default = Collection;
//# sourceMappingURL=collection.js.map