
import path from 'path';
import transform from 'babel-transform-dir';
import rimraf from 'rimraf';

const cleanLib =()=>new Promise((resolve, reject) => {
  rimraf('./lib', { force: true }, (err, result)=>err ? reject(err) : resolve(result))
});

async function build() { 
  await cleanLib();
  console.log('Cleaned old lib!');
  transform('./src', './lib').then(()=>console.log('new libs built!'), (e)=>console.log(e));

}
build();